import multiprocessing as mp
from multiprocessing import Process, Lock

# How many processors do we have?
cpu_count = mp.cpu_count()

def hello(index, output_lock):
    # Protect the print with the lock
    output_lock.acquire()
    print("Hello from processor " + str(index))
    output_lock.release()

def main():
    # Create a Process for each processor
    processes = []
    for i in range(cpu_count):
        # Create a lock and pass it to hello
        output_lock = Lock()
        new_process = Process(target=hello, args=(i, output_lock))
        processes.append(new_process)
        new_process.start()

    # Wait for all the processes to terminate
    for process in processes:
        process.join()

if __name__ == "__main__":
    main()
