import multiprocessing as mp
from multiprocessing import Process

# How many processors do we have?
cpu_count = mp.cpu_count()

def hello(index):
    print("Hello from processor " + str(index))

def main():
    # Create a Process for each processor
    processes = []
    for i in range(cpu_count):
        new_process = Process(target=hello, args=(i,))
        processes.append(new_process)
        new_process.start()

    # Wait for all the processes to terminate
    for process in processes:
        process.join()

if __name__ == "__main__":
    main()
