import mandelbrot
from time import time
from PIL import Image

def create_image():
    # Choose the size and communicate it to the mandelbrot module
    width, height = (280 * 2, 300 * 2)
    mandelbrot.set_size((width, height))

    # Create a new image
    output = Image.new("RGB", (width, height))

    start = time()
    # Compute the color for each pixel in the image
    for x in range(width):
        for y in range(height):
            pixel = mandelbrot.compute_pixel((x, y))
            output.putpixel((x, y), pixel)
    end = time()
    print("It took {:.4} seconds".format(end - start))

    # Save the image
    output.save("/tmp/out.png")

def main():
    create_image()

if __name__ == "__main__":
    main()
