import math

# This script computes the pixel color of the Mandelbrot fractal

top = 1000
iterations = 256

byte = lambda x: max(0, min(256, x))

def mandelbrot(z , c , n=iterations):
    if abs(z) > top:
        return n
    else:
        if n > 0:
            return mandelbrot(z ** 2 + c, c, n - 1)
        else:
            return n

mandel_start, mandel_stop = ((-2,-1.5), (0.8, 1.5))

def set_size(size):
    global image_size
    global mandel_step
    image_size = size # (280 * 2, 300 * 2)
    mandel_step = ( (mandel_stop[0] - mandel_start[0]) / image_size[0],  (mandel_stop[1] - mandel_start[1]) / image_size[1])

image_size = (280 * 2, 300 * 2)
mandel_step = (1, 1)
set_size(image_size)

space = 256 * 3
exponent = 12
factor = (space ** (1/exponent))

def compute_pixel(coord):
    x, y = coord
    value = (mandelbrot(0, (mandel_start[0] + x * mandel_step[0]) + 1j * (mandel_start[1] + y * mandel_step[1])).real / iterations)
    value = (value * factor) ** exponent
    value = int(value)
    return (byte(value), byte(value - 256), byte(value - 512))
